Index: codes/icosagcm/devel/src/output/xios_mod.F90
===================================================================
--- codes/icosagcm/devel/src/output/xios_mod.F90	(revision 879)
+++ codes/icosagcm/devel/src/output/xios_mod.F90	(revision 880)
@@ -473,469 +290,6 @@
    CALL bcast_omp(field)
  END SUBROUTINE
-
- SUBROUTINE xios_read_field_scalar(name,field,nlev,nq)
- USE genmod
- USE mpipara
- USE xios
- USE grid_param
- USE domain_mod
- USE dimensions
- USE spherical_geom_mod
- USE geometry
- USE mpi_mod
- IMPLICIT NONE 
-   CHARACTER(LEN=*),INTENT(IN) :: name
-   TYPE(t_field), POINTER :: field(:)
-   INTEGER,INTENT(IN) :: nlev
-   INTEGER,INTENT(IN) :: nq
-   
-   REAL(rstd) :: field_tmp(ncell_i,nlev,nq)
-   TYPE(t_domain),POINTER :: d
-   INTEGER :: n,i,j,ij,ind
-
-   CALL xios_recv_field(name,field_tmp)
-   
-   IF (field(1)%ndim==2) THEN
-     n=0
-     DO ind=1,ndomain
-       
-       d=>domain(ind)
-        
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           IF (d%own(i,j)) THEN
-             n=n+1
-             ij=d%iim*(j-1)+i
-             field(ind)%rval2d(ij)=field_tmp(n,1,1)
-           ENDIF
-         ENDDO
-       ENDDO
-     ENDDO
-   ELSE IF (field(1)%ndim==3) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-        
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           IF (d%own(i,j)) THEN
-             n=n+1
-             ij=d%iim*(j-1)+i
-             field(ind)%rval3d(ij,:)=field_tmp(n,:,1)
-           ENDIF
-         ENDDO
-       ENDDO
-     ENDDO
-   ELSE IF (field(1)%ndim==4) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-        
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           IF (d%own(i,j)) THEN
-             n=n+1
-             ij=d%iim*(j-1)+i
-             field(ind)%rval4d(ij,:,:)=field_tmp(n,:,:)
-           ENDIF
-         ENDDO
-       ENDDO
-     ENDDO     
-   ENDIF
- 
- END SUBROUTINE xios_read_field_scalar
-
- SUBROUTINE xios_write_field_U(name,field,nlev,nq)
- USE genmod
- USE mpipara
- USE xios
- USE grid_param
- USE domain_mod
- USE dimensions
- USE spherical_geom_mod
- USE geometry
- USE mpi_mod
- IMPLICIT NONE 
-   CHARACTER(LEN=*),INTENT(IN) :: name
-   TYPE(t_field), POINTER :: field(:)
-   INTEGER,INTENT(IN) :: nlev
-   INTEGER,INTENT(IN) :: nq
-   
-   REAL(rstd) :: field_tmp(ncell_e,nlev,nq)
-   TYPE(t_domain),POINTER :: d
-   INTEGER :: n,i,j,k,ij,ind
-   
-   IF (field(1)%ndim==2) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind)
-       CALL swap_geometry(ind)
-
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           DO k=0,5
-             IF (d%edge_assign_domain(k,i,j)==domloc_glo_ind(ind) .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j &
-                                                                                 .AND. d%edge_assign_pos(k,i,j)==k) THEN
-               n=n+1
-               ij=iim*(j-1)+i
-               Field_tmp(n,1,1)=d%edge_assign_sign(k,i,j)*field(ind)%rval2d(ij+d%u_pos(k+1))
-             ENDIF
-           ENDDO
-         ENDDO
-       ENDDO
-     ENDDO       
-  
-   ELSE IF (field(1)%ndim==3) THEN
-
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind)
-       CALL swap_geometry(ind)
-
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           DO k=0,5
-             IF (d%edge_assign_domain(k,i,j)==domloc_glo_ind(ind) .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j &
-                                                                                  .AND. d%edge_assign_pos(k,i,j)==k) THEN
-               n=n+1
-               ij=iim*(j-1)+i
-               Field_tmp(n,:,1)=d%edge_assign_sign(k,i,j)*field(ind)%rval3d(ij+d%u_pos(k+1),:)
-             ENDIF
-           ENDDO
-         ENDDO
-       ENDDO
-     ENDDO       
-
-   ELSE IF (field(1)%ndim==4) THEN
-
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind)
-       CALL swap_geometry(ind)
-
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           DO k=0,5
-             IF (d%edge_assign_domain(k,i,j)==domloc_glo_ind(ind) .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j &
-                                                                                  .AND. d%edge_assign_pos(k,i,j)==k) THEN
-               n=n+1
-               ij=iim*(j-1)+i
-               Field_tmp(n,:,:)=d%edge_assign_sign(k,i,j)*field(ind)%rval4d(ij+d%u_pos(k+1),:,:)
-             ENDIF
-           ENDDO
-         ENDDO
-       ENDDO
-     ENDDO       
-
-   ENDIF
-   
-   CALL xios_send_field(name,field_tmp)
- 
- END SUBROUTINE xios_write_field_u 
-
-
- SUBROUTINE xios_read_field_u(name,field,nlev,nq)
- USE genmod
- USE mpipara
- USE xios
- USE grid_param
- USE domain_mod
- USE dimensions
- USE spherical_geom_mod
- USE geometry
- USE mpi_mod
- IMPLICIT NONE 
-   CHARACTER(LEN=*),INTENT(IN) :: name
-   TYPE(t_field), POINTER :: field(:)
-   INTEGER,INTENT(IN) :: nlev
-   INTEGER,INTENT(IN) :: nq
-   
-   REAL(rstd) :: field_tmp(ncell_e,nlev,nq)
-   TYPE(t_domain),POINTER :: d
-   INTEGER :: n,i,j,k,ij,ind
-
-   CALL xios_recv_field(name,field_tmp)
-   
-   IF (field(1)%ndim==2) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind)
-       CALL swap_geometry(ind)
-
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           DO k=0,5
-             IF (d%edge_assign_domain(k,i,j)==domloc_glo_ind(ind) .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j &
-                                                                                 .AND. d%edge_assign_pos(k,i,j)==k) THEN
-               n=n+1
-               ij=iim*(j-1)+i
-               field(ind)%rval2d(ij+d%u_pos(k+1))=Field_tmp(n,1,1)*d%edge_assign_sign(k,i,j)
-             ENDIF
-           ENDDO
-         ENDDO
-       ENDDO
-     ENDDO       
-  
-   ELSE IF (field(1)%ndim==3) THEN
-
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind)
-       CALL swap_geometry(ind)
-
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           DO k=0,5
-             IF (d%edge_assign_domain(k,i,j)==domloc_glo_ind(ind) .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j &
-                                                                                  .AND. d%edge_assign_pos(k,i,j)==k) THEN
-               n=n+1
-               ij=iim*(j-1)+i
-               field(ind)%rval3d(ij+d%u_pos(k+1),:)=Field_tmp(n,:,1)*d%edge_assign_sign(k,i,j)
-             ENDIF
-           ENDDO
-         ENDDO
-       ENDDO
-     ENDDO       
-
-   ELSE IF (field(1)%ndim==4) THEN
-
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind)
-       CALL swap_geometry(ind)
-
-       DO j=d%jj_begin,d%jj_end
-         DO i=d%ii_begin,d%ii_end
-           DO k=0,5
-             IF (d%edge_assign_domain(k,i,j)==domloc_glo_ind(ind) .AND. d%edge_assign_i(k,i,j)==i .AND. d%edge_assign_j(k,i,j)==j &
-                                                                                  .AND. d%edge_assign_pos(k,i,j)==k) THEN
-               n=n+1
-               ij=iim*(j-1)+i
-               field(ind)%rval4d(ij+d%u_pos(k+1),:,:)=Field_tmp(n,:,:)*d%edge_assign_sign(k,i,j)
-             ENDIF
-           ENDDO
-         ENDDO
-       ENDDO
-     ENDDO       
-
-   ENDIF
-   
- 
- END SUBROUTINE xios_read_field_u 
-
-
-
-      
- SUBROUTINE xios_write_field_vort(name,field,nlev,iq)
- USE genmod
- USE mpipara
- USE xios
- USE grid_param
- USE domain_mod
- USE dimensions
- USE spherical_geom_mod
- USE geometry
- USE mpi_mod
- IMPLICIT NONE 
-   CHARACTER(LEN=*),INTENT(IN) :: name
-   TYPE(t_field), POINTER :: field(:)
-   INTEGER,INTENT(IN) :: nlev
-   INTEGER,INTENT(IN),OPTIONAL :: iq
-   
-   REAL(rstd) :: field_tmp(ncell_v,nlev)
-   TYPE(t_domain),POINTER :: d
-   INTEGER :: n,i,j,ij,ind
-   
-   IF (field(1)%ndim==2) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind)  
-       
-       DO j=d%jj_begin+1,d%jj_end
-         DO i=d%ii_begin,d%ii_end-1
-           n=n+1
-           ij=iim*(j-1)+i
-           Field_tmp(n,1)=field(ind)%rval2d(ij+z_down)
-         ENDDO
-       ENDDO
-
-       DO j=d%jj_begin,d%jj_end-1
-         DO i=d%ii_begin+1,d%ii_end
-           n=n+1
-           ij=iim*(j-1)+i
-           Field_tmp(n,1)=field(ind)%rval2d(ij+z_up)
-          ENDDO
-       ENDDO
-          
-     ENDDO
-
-   ELSE IF (field(1)%ndim==3) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind)    
-             
-       DO j=d%jj_begin+1,d%jj_end
-         DO i=d%ii_begin,d%ii_end-1
-           n=n+1
-           ij=iim*(j-1)+i
-           Field_tmp(n,:)=field(ind)%rval3d(ij+z_down,:)
-         ENDDO
-       ENDDO
-
-       DO j=d%jj_begin,d%jj_end-1
-         DO i=d%ii_begin+1,d%ii_end
-           n=n+1
-           ij=iim*(j-1)+i
-           Field_tmp(n,:)=field(ind)%rval3d(ij+z_up,:)
-          ENDDO
-       ENDDO
-          
-     ENDDO
-
-   ELSE IF (field(1)%ndim==4) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind) 
-               
-       DO j=d%jj_begin+1,d%jj_end
-         DO i=d%ii_begin,d%ii_end-1
-           n=n+1
-           ij=iim*(j-1)+i
-           Field_tmp(n,:)=field(ind)%rval4d(ij+z_down,:,iq)
-         ENDDO
-       ENDDO
-
-       DO j=d%jj_begin,d%jj_end-1
-         DO i=d%ii_begin+1,d%ii_end
-           n=n+1
-           ij=iim*(j-1)+i
-           Field_tmp(n,:)=field(ind)%rval4d(ij+z_up,:,iq)
-          ENDDO
-       ENDDO
-          
-     ENDDO
-
-   ENDIF
-   
-   CALL xios_send_field(name,field_tmp)
- 
- END SUBROUTINE xios_write_field_vort 
-
- SUBROUTINE xios_read_field_vort(name,field,nlev,iq)
- USE genmod
- USE mpipara
- USE xios
- USE grid_param
- USE domain_mod
- USE dimensions
- USE spherical_geom_mod
- USE geometry
- USE mpi_mod
- IMPLICIT NONE 
-   CHARACTER(LEN=*),INTENT(IN) :: name
-   TYPE(t_field), POINTER :: field(:)
-   INTEGER,INTENT(IN) :: nlev
-   INTEGER,INTENT(IN),OPTIONAL :: iq
-   
-   REAL(rstd) :: field_tmp(ncell_v,nlev)
-   TYPE(t_domain),POINTER :: d
-   INTEGER :: n,i,j,ij,ind
-
-   CALL xios_recv_field(name,field_tmp)
-
-   
-   IF (field(1)%ndim==2) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind)  
-       
-       DO j=d%jj_begin+1,d%jj_end
-         DO i=d%ii_begin,d%ii_end-1
-           n=n+1
-           ij=iim*(j-1)+i
-           field(ind)%rval2d(ij+z_down)=Field_tmp(n,1)
-         ENDDO
-       ENDDO
-
-       DO j=d%jj_begin,d%jj_end-1
-         DO i=d%ii_begin+1,d%ii_end
-           n=n+1
-           ij=iim*(j-1)+i
-           Field_tmp(n,1)=field(ind)%rval2d(ij+z_up)
-           field(ind)%rval2d(ij+z_up)=Field_tmp(n,1)
-          ENDDO
-       ENDDO
-          
-     ENDDO
-
-   ELSE IF (field(1)%ndim==3) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind)    
-             
-       DO j=d%jj_begin+1,d%jj_end
-         DO i=d%ii_begin,d%ii_end-1
-           n=n+1
-           ij=iim*(j-1)+i
-           field(ind)%rval3d(ij+z_down,:)=Field_tmp(n,:)
-         ENDDO
-       ENDDO
-
-       DO j=d%jj_begin,d%jj_end-1
-         DO i=d%ii_begin+1,d%ii_end
-           n=n+1
-           ij=iim*(j-1)+i
-           field(ind)%rval3d(ij+z_up,:)=Field_tmp(n,:)
-          ENDDO
-       ENDDO
-          
-     ENDDO
-
-   ELSE IF (field(1)%ndim==4) THEN
-     n=0
-     DO ind=1,ndomain
-       d=>domain(ind)
-       CALL swap_dimensions(ind) 
-               
-       DO j=d%jj_begin+1,d%jj_end
-         DO i=d%ii_begin,d%ii_end-1
-           n=n+1
-           ij=iim*(j-1)+i
-           field(ind)%rval4d(ij+z_down,:,iq)=Field_tmp(n,:)
-         ENDDO
-       ENDDO
-
-       DO j=d%jj_begin,d%jj_end-1
-         DO i=d%ii_begin+1,d%ii_end
-           n=n+1
-           ij=iim*(j-1)+i
-           field(ind)%rval4d(ij+z_up,:,iq)=Field_tmp(n,:)
-          ENDDO
-       ENDDO
-          
-     ENDDO
-
-   ENDIF
- 
- END SUBROUTINE xios_read_field_vort 
-
-
-
-
   
  SUBROUTINE xios_write_field_finalize
- IMPLICIT NONE
-
 !$OMP BARRIER
 !$OMP MASTER 
@@ -943,9 +297,7 @@
 !$OMP END MASTER
 !$OMP BARRIER
-
  END SUBROUTINE xios_write_field_finalize
 
  SUBROUTINE xios_set_context
- IMPLICIT NONE   
   TYPE(xios_context) :: ctx_hdl
 
@@ -971,12 +323,8 @@
   
   SUBROUTINE xios_init
-   IMPLICIT NONE
-         
-    using_xios=.FALSE.
-    
+    using_xios=.FALSE.    
   END SUBROUTINE xios_init
   
   SUBROUTINE xios_send_field_scalar(name,field)
-  IMPLICIT NONE
     CHARACTER(LEN=*),INTENT(IN) :: name
     REAL,INTENT(IN) :: field
@@ -984,5 +332,4 @@
 
   SUBROUTINE xios_send_field_1d(name,field)
-  IMPLICIT NONE
     CHARACTER(LEN=*),INTENT(IN) :: name
     REAL,INTENT(IN) :: field(:)
@@ -991,5 +338,4 @@
   SUBROUTINE xios_write_field(name,field)
   USE field_mod
-  IMPLICIT NONE 
    CHARACTER(LEN=*),INTENT(IN) :: name
    TYPE(t_field), POINTER :: field(:)
@@ -998,5 +344,4 @@
   SUBROUTINE xios_read_field(name,field)
   USE field_mod
-  IMPLICIT NONE 
    CHARACTER(LEN=*),INTENT(IN) :: name
    TYPE(t_field), POINTER :: field(:)
@@ -1010,5 +355,4 @@
  
   SUBROUTINE xios_update_calendar(step)
-  IMPLICIT NONE
    INTEGER, INTENT(IN):: step  
   END SUBROUTINE xios_update_calendar
Index: codes/icosagcm/devel/src/sphere/compute_geometry.f90
===================================================================
--- codes/icosagcm/devel/src/sphere/compute_geometry.f90	(revision 879)
+++ codes/icosagcm/devel/src/sphere/compute_geometry.f90	(revision 880)
@@ -1,4 +1,18 @@
 MODULE compute_geometry_mod
   USE geometry
+  USE dimensions
+
+  USE domain_mod, ONLY : t_domain, t_cellset, &
+       domain, ndomain, assigned_domain, &
+       domain_glo, ndomain_glo, domloc_glo_ind, swap_needed
+  USE omp_para, ONLY : is_omp_level_master, is_master
+  USE transfert_mod, ONLY : req_i0, req_i1, t_message, transfert_request, transfert_message, init_message
+
+  USE spherical_geom_mod, ONLY : xyz2lonlat, circumcenter, &
+       compute_centroid, centroid, &
+       surf_triangle, dist_cart, div_arc_bis, &
+       schmidt_transform
+  USE vector, ONLY : norm, cross_product2
+
   IMPLICIT NONE
   PRIVATE
@@ -10,12 +24,5 @@
 
   SUBROUTINE update_circumcenters 
-    USE domain_mod
-    USE dimensions
-    USE spherical_geom_mod
-    USE vector
-    USE transfert_mod
-    USE omp_para
-
-    IMPLICIT NONE
+
     REAL(rstd) :: x1(3),x2(3)
     REAL(rstd) :: vect(3,6)
@@ -36,5 +43,5 @@
     
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
+
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -55,10 +62,5 @@
 
   SUBROUTINE remap_schmidt_loc
-    USE spherical_geom_mod
     USE getin_mod
-    USE omp_para
-    USE domain_mod
-    USE dimensions
-    IMPLICIT NONE
     INTEGER :: ind,i,j,n
     REAL(rstd) :: schmidt_factor, schmidt_lon, schmidt_lat
@@ -91,13 +93,5 @@
 
   SUBROUTINE optimize_geometry
-  USE metric
-  USE spherical_geom_mod
-  USE domain_mod
-  USE dimensions
-  USE transfert_mod
-  USE vector
   USE getin_mod
-  USE omp_para
-  IMPLICIT NONE
     INTEGER :: nb_it=0
     TYPE(t_domain),POINTER :: d
@@ -193,8 +187,5 @@
     ! copy position of generators and vertices back into domain(:)%xyz/vertex
     ! so that XIOS/create_header_gen gets the right values
-    USE omp_para
-    USE dimensions
-    USE domain_mod 
-    USE transfert_mpi_mod
+    USE transfert_mpi_mod, ONLY : gather_field, bcast_field
 
     INTEGER :: ind,i,j,k,n
@@ -253,12 +244,4 @@
   SUBROUTINE set_geometry
   USE metric
-  USE vector
-  USE spherical_geom_mod
-  USE domain_mod
-  USE dimensions
-  USE transfert_mod
-  USE getin_mod
-  USE omp_para
-  IMPLICIT NONE
 
     REAL(rstd) :: surf(6)
@@ -279,7 +262,4 @@
     CALL remap_schmidt_loc
     CALL update_circumcenters
-    ! copy position of generators and vertices back into domain(:)%xyz/vertex
-    ! so that XIOS gets the right values
-    CALL update_domain
 
     DO ind=1,ndomain
@@ -527,7 +507,6 @@
  
   END SUBROUTINE set_geometry
-  
+
   SUBROUTINE compute_wee(n,pos,w)
-  IMPLICIT NONE
     INTEGER,INTENT(IN) :: n
     INTEGER,INTENT(IN) :: pos
@@ -555,12 +534,9 @@
    END SUBROUTINE compute_wee
             
-
   
   SUBROUTINE compute_geometry
     USE grid_param
-    USE domain_mod, ONLY : swap_needed
     USE init_unstructured_mod, ONLY : read_local_mesh
-    IMPLICIT NONE
-
+    USE set_bounds_mod, ONLY : set_bounds
     CALL allocate_geometry
 
@@ -568,4 +544,9 @@
     CASE(grid_ico)
        CALL set_geometry
+       ! copy position of generators and vertices back into domain_glo(:)%xyz/vertex
+       ! so that write_field gets the right values
+       CALL update_domain
+       CALL set_bounds(domain_glo, .TRUE.)
+       CALL set_bounds(domain, .FALSE.)
     CASE(grid_unst)
        swap_needed=.FALSE.
